#!/usr/bin/python3
# -*- coding: utf-8 -*-
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import QWidget, QTextEdit, QVBoxLayout, QDesktopWidget, QListWidget, QListWidgetItem

from mainui.systembutton import *
from mainui.titlebar import *
from utils.db_install_information import *

import gettext
import re
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext


class Package_Massage_Widget(QWidget):
    m_parent = None
    item_num = 0

    def __init__(self, parent=None):
        self.m_parent = parent
        super(Package_Massage_Widget, self).__init__(parent)
        self.setWindowFlags(Qt.FramelessWindowHint | Qt.Tool)
        self.setAttribute(Qt.WA_TranslucentBackground)
        self.setWindowTitle(_("Kylin Update Manager"))
        self.mouse_press = False
        self.setWindowFlags(Qt.FramelessWindowHint|Qt.Tool)
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(self.backgroundRole(), QColor(255, 255, 255))
        self.setPalette(palette)
        self.initui()
        self.insert_package_item()
        #self.init_connect()

    def initui(self):
        self.setFixedSize(470, 340)
        self.widget_label = QLabel(self)
        self.widget_label.setFixedWidth(300)
        self.widget_label.setStyleSheet("QLabel{font-size:24px;color:#444444;background-color:white;}")
        self.widget_label.setText(_("Packages information"))
        self.widget_label.move(30, 30)
        self.widget_label.show()
        self.close_btn = SystemButton(False, False, True, self)
        self.close_btn.setGeometry(426, 14, 30, 30)
        self.close_btn.clicked.connect(self.slot_click_close_button)
        self.none_label = QLabel(self)
        self.none_label.setFixedSize(430, 210)
        self.none_label.move(20, 90)
        self.none_label.setWordWrap(True)
        self.none_label.hide()
        self.package_item_list = QListWidget(self)
        self.package_item_list.setFrameShape(QFrame.NoFrame)
        self.package_item_list.setFocusPolicy(Qt.NoFocus)
        self.package_item_list.setSpacing(0)
        self.package_item_list.setFixedSize(430, 210)
        self.package_item_list.move(20, 110)
        self.package_item_list.show()
        self.package_item_list.setStyleSheet(
            "QListWidget{background-color:white;border:1px solid #cfcfcf;}QListWidget::item{background-color:white;height:60px;margin-top:0px;border:0px solid #cfcfcf;}QListWidget::item:hover{background:#F4F4F4;}QListWidget::item:selected{background:#F4F4F4;}")
        self.package_item_list.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
                                                                         QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:0px solid red;height:13px}\
                                                                         QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:rgba(0,0,0,0);height:13px}\
                                                                         QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
                                                                         QScrollBar::handle:vertical{background-color:rgba(0,0,0,20%);width:6px;border-radius:6px;} QScrollBar::handle:vertical:hover{background-color:rgb(0,0,0,10%);opacity:0.1;width:6px;border-radius:6px;}  QScrollBar::handle:vertical:pressed{background-color:rgb(0,0,0,50%);width:6px;border-radius:6px;}\
                                                                         QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
                                                                         QScrollBar::down-arrow:vertical{background-color:rgba(0,0,0,0);}\
                                                                         QScrollBar::add-line:vertical{subcontrol-origin:margin;border:0px solid green;height:13px}")


    #
    # 函数：关闭按钮响应
    #
    def slot_click_close_button(self):
        self.hide()

    #
    #函数：处理各组件的显示
    #
    def insert_package_item(self):
        self.select_package("kylin-update-desktop-security", "安全更新")
        self.select_package("kylin-update-desktop-support", "系统基础组件")
        self.select_package("kylin-update-desktop-ukui", "桌面环境组件")
        self.select_package("kylin-update-desktop-app","基本应用")
        self.select_package("kylin-update-desktop-kernel", "系统内核组件")
        self.select_package("kylin-update-desktop-kernel-3a4000", "系统内核组件")
        self.select_package("kylin-update-desktop-kydroid", "kydroid补丁包")
        self.select_package("kylin-update-patch","补丁包")
        if(self.item_num == 0):
            self.package_item_list.hide()
            self.none_label.setText(_("No package information was detected"))
            self.none_label.setStyleSheet("QLabel{font-size:24px;color:#d88888;border:0px solid #cfcfcf;}")
            self.none_label.setAlignment(Qt.AlignHCenter | Qt.AlignVCenter)
            self.none_label.show()
        else:
            self.package_item_list.show()

    #
    # 函数：添加虚包item
    #
    def add_list_item(self,item):
        appname = item[0]
        version = item[1]
        time = item[2]
        item = QListWidgetItem()
        list_item = ListItemWidget(appname, version, time, self)
        self.package_item_list.addItem(item)
        self.package_item_list.setItemWidget(item, list_item)
        self.item_num = self.item_num + 1

    #
    # 函数：从数据库获取item信息
    #
    def select_package(self,appname,appname1):
        db = install_information()
        db.select_package(appname)
        res = db.cursor.fetchall()
        db1 = install_information()
        db1.select_package(appname1)
        res1 = db1.cursor.fetchall()
        #print(res1)
        if (res == None or res == []) and (res1 == None or res1 == []):
            pass
        elif((res == None or res == []) and (res1 !=None and res1 != [])):
            self.add_list_item(res1[0])
        elif((res1 == None or res1 == []) and (res !=None and res != [])):
            self.add_list_item(res[0])
        else:
            item0 = res[0]
            item1 = res1[0]
            time00 = re.sub("-","",item0[2])
            time01 = re.sub(" ","",time00)
            time02 = re.sub(":","",time01)
            time10 = re.sub("-", "", item1[2])
            time11 = re.sub(" ", "", time10)
            time12 = re.sub(":", "", time11)
            if(int(time12) >= int(time02)):
                self.add_list_item(res1[0])
            else:
                self.add_list_item(res[0])
        db.connect.commit()
        db.cursor.close()
        db.connect.close()
        db1.connect.commit()
        db1.cursor.close()
        db1.connect.close()


    #
    # 函数：鼠标拖动窗口
    #
    def mousePressEvent(self, event):
        if(event.button() == Qt.LeftButton):
            self.mouse_press = True
            self.drag_pos = event.globalPos() - self.pos()
            event.accept()
    def mouseReleaseEvent(self, event):
        self.mouse_press = False
        self.setWindowOpacity(1)
    def mouseMoveEvent(self, event):
        if(self.mouse_press):
            self.move_pos = event.globalPos()
            self.move(self.move_pos - self.drag_pos)
            self.setWindowOpacity(1)
            event.accept()

    def paintEvent(self, event):
        # 阴影
        path = QPainterPath()
        path.setFillRule(Qt.WindingFill)
        pat = QPainter(self)
        pat.setRenderHint(pat.Antialiasing)
        # print(opt.palette.base().color())
        pat.fillPath(path, QBrush(Qt.white))

        color = QColor(0, 0, 0, 50)

        for i in range(10):

            i_path = QPainterPath()
            i_path.setFillRule(Qt.WindingFill)
            ref = QRectF(10 - i, 10 - i, self.width() - (10 - i) * 2, self.height() - (10 - i) * 2)
            if i == 0:
                pass
            else:
                i_path.addRoundedRect(ref, 0, 0)
                color.setAlpha(int(150 - i ** 0.5 * 50))
                pat.setPen(color)
                pat.drawPath(i_path)

        # 主题
        ref = QRectF(10, 10, self.width() - 20, self.height() - 20)
        p = QPainter(self)
        p.setRenderHint(QPainter.Antialiasing)
        p.setBrush(Qt.white)
        p.setPen(Qt.transparent)
        p.setPen(Qt.NoPen)
        # p.drawRect(opt.rect)
        p.drawRoundedRect(ref, 0, 0)

class ListItemWidget(QWidget):

    def __init__(self, appname, version, time, parent=None):
        QWidget.__init__(self,parent)
        self.setFixedSize(430,60)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.appname = appname
        self.version = version
        self.time = time
        self.parent = parent
        self.ui_init()
        self.stylesheet_init()
        self.show()

    #
    # 函数：初始化ui
    #
    def ui_init(self):
        self.applabel = QLabel(self)
        self.applabel.setFixedWidth(250)
        self.applabel.move(10,10)
        self.installed_versionlabel = QLabel(self)
        self.installed_versionlabel.setFixedWidth(250)
        self.installed_versionlabel.move(10, 30)
        self.splitlabel = QLabel(self)
        self.splitlabel.setGeometry(0, 59, self.width(), 3)
        self.splitlabel.show()
        self.installed_time_label = QLabel(self)
        self.installed_time_label.setFixedWidth(120)
        self.installed_time_label.move(280,27)
        self.installed_time_label.show()

    #
    # 函数：初始化样式
    #
    def stylesheet_init(self):
        self.applabel.setStyleSheet("QLabel{font-size:14px;color:#444444;border:0px solid #cfcfcf;}")
        metrics = QFontMetrics(self.applabel.font())
        if (self.appname == "kylin-update-desktop-app"):
            elidedText = metrics.elidedText("基本应用", Qt.ElideRight, self.applabel.width())
        elif (self.appname == "kylin-update-desktop-security"):
            elidedText = metrics.elidedText("安全更新", Qt.ElideRight, self.applabel.width())
        elif (self.appname == "kylin-update-desktop-support"):
            elidedText = metrics.elidedText("系统基础组件", Qt.ElideRight, self.applabel.width())
        elif (self.appname == "kylin-update-desktop-ukui"):
            elidedText = metrics.elidedText("桌面环境组件", Qt.ElideRight, self.applabel.width())
        elif (self.appname == "kylin-update-desktop-kernel"):
            elidedText = metrics.elidedText("系统内核组件", Qt.ElideRight, self.applabel.width())
        elif (self.appname == "kylin-update-desktop-kernel-3a4000"):
            elidedText = metrics.elidedText("系统内核组件", Qt.ElideRight, self.applabel.width())
        elif (self.appname == "kylin-update-desktop-kydroid"):
            elidedText = metrics.elidedText("kydroid补丁包", Qt.ElideRight, self.applabel.width())
        else:
            elidedText = metrics.elidedText(self.appname, Qt.ElideRight, self.applabel.width())
        if elidedText.endswith("…"):
            #self.applabel.setToolTip(self.app_msg.NAME)
            self.applabel.setText(elidedText)
        else:
            self.applabel.setText(elidedText)

        self.setStyleSheet("QToolTip{border-radius:6px;border: 1px solid #888888;background:white;font-size:12px;color:#888888;width:200px;minimum=50px; maximum=300px;}")
        self.splitlabel.setStyleSheet("QLabel{background-color:#eff0ef;border:0px solid #cfcfcf;}")
        self.installed_versionlabel.setText(_("installed version")+":"+self.version)
        self.installed_versionlabel.setStyleSheet("QLabel{font-size:12px;color:#888888;border:0px solid #cfcfcf;}")
        self.installed_time_label.setAlignment(Qt.AlignLeft)
        self.installed_time_label.setStyleSheet("QLabel{font-size:12px;color:#888888;border:0px solid #cfcfcf;}")
        self.installed_time_label.setText(self.time)

    #
    # 函数：用于超过大小用...代替
    #
    def judge_elidedText(self, label, str):
        metrics = QFontMetrics(label.font())
        elidedText = metrics.elidedText(str, Qt.ElideRight, label.width())
        if elidedText.endswith("…"):
            # label.setToolTip(str)
            label.setText(elidedText)
        else:
            label.setText(elidedText)




