#!/usr/bin/python3
# -*- coding: utf-8 -*-

import sys
# reload(sys)
# sys.setdefaultencoding('utf8')
from PyQt5.QtGui import *
from PyQt5.QtCore import *

import gettext

from PyQt5.QtWidgets import QSystemTrayIcon, QApplication

gettext.textdomain("kylin-update-manager")
_ = gettext.gettext

class SystemTray(QSystemTrayIcon):

    process_now = ""
    appname = ""
    statue = ""
    mw = None

    def __init__(self, parent=None):
        QSystemTrayIcon.__init__(self, parent)

        self.mw = parent
        #self.setToolTip("麒麟更新管理器")
        self.setToolTip(_("Kylin Update Manager"))
        self.setIcon(QIcon("./res/icon.png"))
        self.activated.connect(self.slot_click_tray)
        self.show()

    #
    # 函数：托盘提示
    #
    def start_tray_msg(self, msg):
        #self.showMessage("关键更新", "  " + msg, QSystemTrayIcon.Information, 5 * 1000)
        self.showMessage(_("Crucial Update"), "  " + msg, QSystemTrayIcon.Information, 5 * 1000)

    #
    # 函数：点击托盘事件
    #
    def slot_click_tray(self, status):
        # print("is_working:", self.mw.is_working)
        # if (self.mw.is_working == True or self.mw.is_working_c == True):
        if self.mw.is_SP_update:
            item = self.mw.bottom_widget.sp_selection.item(0)
            itemWidget = self.mw.bottom_widget.sp_selection.itemWidget(item)
            if itemWidget.is_working:
                self.showMessage(_("Updating") + ":" + self.appname, self.statue + self.process_now + "%",
                                 QSystemTrayIcon.Information, 5 * 1000)
                return
        else:
            for i in range(self.mw.bottom_widget.lw_all_selection.count()):
                item = self.mw.bottom_widget.lw_all_selection.item(i)
                itemWidget = self.mw.bottom_widget.lw_all_selection.itemWidget(item)
                if itemWidget.is_working:
                    self.showMessage(_("Updating") + ":" + self.appname, self.statue + self.process_now + "%",
                                     QSystemTrayIcon.Information, 5 * 1000)
                    return
        if len(self.mw.crucial_worklist) != 0 or len(self.mw.important_worklist) != 0:
            self.showMessage(_("Updating")+":"+self.appname,self.statue+self.process_now + "%", QSystemTrayIcon.Information, 5 * 1000)


if __name__ == '__main__':
    app = QApplication(sys.argv)
    # QTextCodec.setCodecForTr(QTextCodec.codecForName("UTF-8"))
    # QTextCodec.setCodecForCStrings(QTextCodec.codecForName("UTF-8"))

    globalfont = QFont()
    globalfont.setPixelSize(14)
    globalfont.setFamily("方正黑体_GBK")
    app.setFont(globalfont)
    tray = SystemTray()
    app.exec_()

